#include "buf_ext.h"

int	DEBUG_SpikeEvent = 0;

#define Field(F)	(buffer->F)

/* 6/88 Matt Wilson */
SpikeEvent (buffer,action)
register struct spike_type *buffer;
Action		*action;
{
double 	state;
double 	thresh;
MsgIn	*msg;
int	stat;

    if(Debug(DEBUG_SpikeEvent) > 1){
	ActionHeader("SpikeEvent",buffer,action);
    }
    SELECT_ACTION(action){
    case RESET:
	ClearBuffer(buffer);
	break;
    case PROCESS:
	/*
	** set the default values
	*/
	thresh = buffer->thresh;
	MSGLOOP(buffer,msg){
	case 0:		/* potential */
	    state = MSGVALUE(msg,0);
	    break;
	case 1:		/* threshold */
	    thresh = MSGVALUE(msg,0);
	    break;
	}
	/*
	** evaluate the criteria for spiking.
	** has it exceeded threshold?
	** is it past its refractory state?
	*/
#ifdef FLOATTIME
	if(( state >= thresh) &&
	( !ValidEvent(buffer) ||
	(CurrentEventTime(buffer) <= 
	(SimulationTime() - buffer->abs_refract)
	+ClockValue(0)/2.0))) {
#else
	if(( state >= thresh) &&
	( !ValidEvent(buffer) ||
	(CurrentEventTime(buffer)*global_clock[buffer->clock] <= 
	(SimulationTime() - Field(abs_refract))))) {
#endif
	    /*
	    ** add a spike to the spike event buffer
	    */
	    PutEvent(buffer,(double)Field(output_amp),NULL,WRAP);
	    buffer->state = Field(output_amp);
	} else {
	    buffer->state = 0;
	}
	break;
    case CHECK:
	stat = 0;
	for(msg=buffer->msg_in;msg;msg=msg->next){
	    switch(msg->type){
	    case 0:
		stat = 1;
		break;
	    }
	}
	if(!stat){
	    ErrorMessage("Spike","State input is required.",buffer);
	}
	break;
    default:
	InvalidAction("Spike",buffer,action);
	break;
    }
}
#undef Field

