/**********************************************************
**                                                       **
**                      VIEW MODES                       **
**                                                       **
**********************************************************/


#define BOXVIEW 1	/* Old versions of view */
#define FILLBOXVIEW 2	
#define COLORBOXVIEW 3	/* Displays value both by color and size */
#define COLORVIEW 4
#define SIZEICONVIEW 5  /* Displays by size of a simple icon */
#define COLORICONVIEW 6  /* Displays by color of a simple icon */
#define COLORSIZEICONVIEW 7
	/* Displays by size and color of a simple icon */

#define BIG 1.0e60
#define PSOUT 1

#define XtNboxview "boxview"	
#define XtNfillboxview "fillboxview"	
#define XtNcolorboxview "colorboxview"	
#define XtNcolorview "colorview"
#define XtNsizeiconview "sizeiconview"
#define XtNcoloriconview "coloriconview"
#define XtNcolorsizeiconview "colorsizeiconview"

/**********************************************************
**                                                       **
**                     XVIEW FIELDS                      **
**                                                       **
**********************************************************/

#define XtNpixcolor		"pixcolor"
#define XtNpixreturn	"pixreturn"
#define XtNstoragemode	"storagemode"

#define XtNviewmode		"viewmode"
#define XtNviewicon		"viewicon"
#define XtNpath			"path"
#define XtNfield		"field"

#define XtNvmin			"vmin"
#define XtNvmax			"vmax"
#define XtNautoscale	"autoscale"

#define XtNnx			"nx"
#define XtNny			"ny"
#define XtNautospace	"autospace"

#define XtNox			"ox"
#define XtNoy			"oy"
#define XtNoz			"oz"


#define	XtCPixcolor		"Pixcolor"
#define	XtCPixreturn	"Pixreturn"
#define	XtCStoragemode	"Storagemode"

#define	XtCViewmode		"Viewmode"
#define	XtCViewicon		"Viewicon"
#define	XtCPath			"Path"
#define	XtCField		"Field"

#define	XtCVmin			"Vmin"
#define	XtCVmax			"Vmax"
#define	XtCAutoscale	"Autoscale"

#define	XtCNx			"Nx"
#define	XtCNy			"Ny"
#define	XtCAutospace	"Autospace"

#define XtCOx			"Ox"
#define XtCOy			"Oy"
#define XtCOz			"Oz"

#define	XtNelmview		"elmview"
#define	XtNcoordview	"coordview"
#define	XtNfileview		"fileview"

#define VIEW_PIX_CORE_TYPE \
	PIX_CORE_TYPE \
	/*  private fields */ \
	Pix     **icons; \
	int     *value; \
	/* public fields */ \
	char    *viewmode; \
	char    *viewicon; \
	char	*pixcolor; \
	char	*hlhistmode; \
	char	*hldispmode; \
	char	*vmin; \
	char	*vmax; \
	char	*autoscale; \
	char	*nx; \
	char	*ny; \
	char	*autospace; \
	char	*path; \
	char	*field; \
	char	*ox; \
	char	*oy; \
	char	*oz;

typedef struct view_pix_struct {
	VIEW_PIX_CORE_TYPE
} ViewPix, *ViewPixPtr;
